package com.yolo.keyboard.service.userinvites;

import com.yolo.keyboard.controller.admin.userinvites.vo.KeyboardUserInvitesPageReqVO;
import com.yolo.keyboard.controller.admin.userinvites.vo.KeyboardUserInvitesSaveReqVO;
import com.yolo.keyboard.dal.dataobject.userinvites.KeyboardUserInvitesDO;
import com.yolo.keyboard.dal.mysql.userinvites.KeyboardUserInvitesMapper;
import com.yolo.keyboard.framework.common.pojo.PageResult;
import com.yolo.keyboard.framework.common.util.object.BeanUtils;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import java.util.List;

import static com.yolo.keyboard.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.yolo.keyboard.module.infra.enums.ErrorCodeConstants.USER_INVITES_NOT_EXISTS;

/**
 * 用户邀请关系绑定台账表，记录新用户最终归属的邀请人 Service 实现类
 *
 * @author ziin
 */
@Service
@Validated
public class KeyboardUserInvitesServiceImpl implements KeyboardUserInvitesService {

    @Resource
    private KeyboardUserInvitesMapper userInvitesMapper;

    @Override
    public Long createUserInvites(KeyboardUserInvitesSaveReqVO createReqVO) {
        // 插入
        KeyboardUserInvitesDO userInvites = BeanUtils.toBean(createReqVO, KeyboardUserInvitesDO.class);
        userInvitesMapper.insert(userInvites);

        // 返回
        return userInvites.getId();
    }

    @Override
    public void updateUserInvites(KeyboardUserInvitesSaveReqVO updateReqVO) {
        // 校验存在
        validateUserInvitesExists(updateReqVO.getId());
        // 更新
        KeyboardUserInvitesDO updateObj = BeanUtils.toBean(updateReqVO, KeyboardUserInvitesDO.class);
        userInvitesMapper.updateById(updateObj);
    }

    @Override
    public void deleteUserInvites(Long id) {
        // 校验存在
        validateUserInvitesExists(id);
        // 删除
        userInvitesMapper.deleteById(id);
    }

    @Override
        public void deleteUserInvitesListByIds(List<Long> ids) {
        // 删除
        userInvitesMapper.deleteByIds(ids);
        }


    private void validateUserInvitesExists(Long id) {
        if (userInvitesMapper.selectById(id) == null) {
            throw exception(USER_INVITES_NOT_EXISTS);
        }
    }

    @Override
    public KeyboardUserInvitesDO getUserInvites(Long id) {
        return userInvitesMapper.selectById(id);
    }

    @Override
    public PageResult<KeyboardUserInvitesDO> getUserInvitesPage(KeyboardUserInvitesPageReqVO pageReqVO) {
        return userInvitesMapper.selectPage(pageReqVO);
    }

}